/*

  This file is a part of GRALESHELL, a program to facilitate the simulation
  and inversion of gravitational lenses, based on the GRALE library.

  Copyright (C) 2008-2012 Jori Liesenborgs

  Contact: jori.liesenborgs@gmail.com
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  
*/

#ifndef CMDGRID_H

#define CMDGRID_H

#include <shellp/shellcommand.h>
#include <shellp/shellcmdrealarg.h>
#include <shellp/shellcmdintarg.h>
#include <shellp/shellcmdboolarg.h>
#include <shellp/shellcmdstringarg.h>

class CmdGridNewUniform : public shellp::ShellCommand
{
public:
	CmdGridNewUniform(const std::string &cmdname);
	~CmdGridNewUniform();
	bool execute();
private:
	shellp::ShellCmdRealArg *centerxarg, *centeryarg, *sizearg;
	shellp::ShellCmdIntArg *subdivarg;
};

class CmdGridNewLens : public shellp::ShellCommand
{
public:
	CmdGridNewLens(const std::string &cmdname);
	~CmdGridNewLens();
	bool execute();
private:
	shellp::ShellCmdRealArg *centerxarg, *centeryarg, *sizearg;
	shellp::ShellCmdIntArg *minsquaresarg, *maxsquaresarg;
	shellp::ShellCmdIntArg *xintarg, *yintarg;
	shellp::ShellCmdBoolArg *m_pIgnoreSheet, *m_pKeepLargerArg;
};

class CmdGridPlot : public shellp::ShellCommand
{
public:
	CmdGridPlot(const std::string &cmdName);
	~CmdGridPlot();
	bool execute();
private:
	shellp::ShellCmdStringArg *m_pFileNameArg;
};

#endif // CMDGRID_H

